#pragma once

#include "cgp/cgp.hpp"

using namespace cgp;

struct ball {
	int N;

	std::vector<vec3> v;
	std::vector<vec3> pos;
	std::vector<vec3> color;

	mesh_drawable mesh;

	void initialize(int n);
	void simulate(float dt, float terrain_length);
	void add_ball(vec3 new_pos, vec3 new_dir);
	void reset();
};

vec3 terrain_orientation(float x, float y, float terrain_length);

